package com.itsoulos.menuexample;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.view.GravityCompat;
import androidx.drawerlayout.widget.DrawerLayout;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Html;
import android.view.Display;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;

import java.util.ArrayList;

public class MainActivity extends AppCompatActivity {
    DrawerLayout mainLayout=null;
    LinearLayout l1=null;
    ListView list=null;
    int width=0,height=0;

    public void makeHeader(String title)
    {
        LinearLayout header=new LinearLayout(this);
        l1.addView(header);
        header.setBackgroundColor(Color.BLUE);
        LinearLayout.LayoutParams hparams=(LinearLayout.LayoutParams)header.getLayoutParams();
        hparams.width=width;
        hparams.height=height/10;
        header.setLayoutParams(hparams);
        ImageView openDrawer=new ImageView(this);
        header.addView(openDrawer);
        TextView t=new TextView(this);
        header.addView(t);
        LinearLayout.LayoutParams oparams=(LinearLayout.LayoutParams)openDrawer.getLayoutParams();
        oparams.leftMargin=width/20;
        oparams.topMargin=hparams.height/10;
        oparams.width=width/10;
        oparams.height=hparams.height-2*oparams.topMargin;
        openDrawer.setLayoutParams(oparams);
        Bitmap b1= BitmapFactory.decodeResource(getResources(), R.drawable.menuopen);
        b1=b1.createScaledBitmap(b1, oparams.width, oparams.height, true);
        openDrawer.setImageBitmap(b1);
        openDrawer.setClickable(true);
        openDrawer.setOnClickListener(new View.OnClickListener()
        {

            @Override
            public void onClick(View v) {
                if(mainLayout.isDrawerOpen(list)) mainLayout.closeDrawer(list);
                else mainLayout.openDrawer(list);
            }

        });
        LinearLayout.LayoutParams tparams=(LinearLayout.LayoutParams)t.getLayoutParams();
        tparams.leftMargin=width/20;
        tparams.topMargin=hparams.height/10;
        t.setLayoutParams(tparams);
        t.setTextSize(24);
        t.setTextColor(Color.YELLOW);
        t.setText(title);
    }

    public void makeHome()
    {
        if(l1!=null)
        {
            l1.removeAllViews();
        }
        else
        {
            l1=new LinearLayout(this);
            mainLayout.addView(l1);
            l1.setId(100);
            l1.setOrientation(LinearLayout.VERTICAL);
            DrawerLayout.LayoutParams l1params=(DrawerLayout.LayoutParams)l1.getLayoutParams();
            l1params.height=height-height/40;
            l1params.width=width;
            l1.setLayoutParams(l1params);
            l1.setBackgroundColor(Color.DKGRAY);
        }
    }

    public void makeTab1()
    {
        makeHome();
        makeHeader("Tab1");
        Button b1=new Button(this);
        l1.addView(b1);
        b1.setText("Button1");
    }

    public void makeTab2()
    {
        makeHome();
        makeHeader("Tab2");
        ArrayList<String> sitems=new ArrayList<String>();
        sitems.add("SPINNER1");
        sitems.add("SPINNER2");
        sitems.add("SPINNER3");
        ArrayAdapter<String> adapter=new ArrayAdapter<String>(this,android.R.layout.simple_spinner_dropdown_item,sitems);
        Spinner t=new Spinner(this);
        l1.addView(t);
        t.setAdapter(adapter);
    }

    public void makeTab3()
    {
        makeHome();
        makeHeader("Tab3");
        TextView info=new TextView(this);
        l1.addView(info);
        info.setText(Html.fromHtml("<h3>Main Info</h3>Simple text<br>follows<br>"));
        info.setGravity(Gravity.CENTER);
    }

    public void makeList()
    {
        ArrayList<String> s=new ArrayList<String>();
        s.add("Tab1");
        s.add("Tab2");
        s.add("Tab3");
        ArrayAdapter<String> adapter=new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1,s);
        list=new ListView(this);
        TextView padding=new TextView(this);
        padding.setHeight(height/15);
        list.addHeaderView(padding);
        padding.setBackgroundColor(Color.BLUE);
        padding.setTextColor(Color.YELLOW);
        padding.setTextSize(20);
        padding.setText("Make a choice");
        padding.setGravity(Gravity.CENTER);
        list.setAdapter(adapter);
        mainLayout.addView(list);
        DrawerLayout.LayoutParams cparams=(DrawerLayout.LayoutParams)list.getLayoutParams();
        cparams.width=3*width/4;
        cparams.height=DrawerLayout.LayoutParams.MATCH_PARENT;
        cparams.gravity=Gravity.START;
        list.setLayoutParams(cparams);
        list.setAdapter(adapter);
        list.setBackgroundColor(Color.LTGRAY);
        list.setOnItemClickListener(new AdapterView.OnItemClickListener()
        {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                if(position==0) return ;
                if(position==1)
                    makeTab1();
                else
                if(position==2)
                    makeTab2();
                else
                if(position==3)
                    makeTab3();
                mainLayout.closeDrawer(list);

            }

        });
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mainLayout=new DrawerLayout(this);
        mainLayout.setDrawerShadow(R.drawable.drawershadow, GravityCompat.START);
        this.setContentView(mainLayout);
        Display display = getWindowManager().getDefaultDisplay();
        width = display.getWidth();
        height = display.getHeight();
        makeTab1();
        makeList();
    }
}
